#!/bin/sh

vialver=0p4p1
nathanaver=r4b4

# -- CHANGE THESE SETTINGS PER KEYBOARD --
model=f77nlck
keymap=nathana
# ----------------------------------------

#dfuprog="$(dirname "$0")/bin/dfu-programmer"
#opt_check="get bootloader-version"
#opt_erase="erase"
#opt_reset="reset"
#opt_flash="flash --force"
#opt_eeprom="flash --eeprom --force"
dfuprog=/usr/bin/dfu-programmer
opt_check="get bootloader-version"
opt_erase="erase"
opt_reset="reset"
opt_flash="flash"
opt_eeprom="flash-eeprom"
target=atmega32u2
output=/tmp/flash-debian.log

echo
echo Preparing to flash firmware for \""$model"\" with keymap \""$keymap"\"...
$dfuprog $target $opt_check >> $output 2>&1
if [ $? -gt 0 ]; then
echo
    echo Please plug in keyboard to be flashed, and put into bootloader/flash mode.
    echo Waiting for keyboard...
    $dfuprog $target $opt_check >> $output 2>&1
    while [ $? -gt 0 ]; do
        sleep 1s
        $dfuprog $target $opt_check >> $output 2>&1
    done
fi
echo
echo \* Wiping existing flash memory and EEPROM...
$dfuprog $target $opt_erase >> $output 2>&1
$dfuprog $target $opt_eeprom --suppress-validation "$(dirname "$0")"/bin/reset.eep >> $output 2>&1
$dfuprog $target $opt_flash "$(dirname "$0")"/bin/eeprom_eraser.hex >> $output 2>&1
echo \* Resetting controller for main flash...
$dfuprog $target $opt_reset >> $output 2>&1
$dfuprog $target $opt_check >> $output 2>&1
while [ $? -gt 0 ]; do
    sleep 1s
    $dfuprog $target $opt_check >> $output 2>&1
done
echo \* Flashing \""$model"\" firmware...
$dfuprog $target $opt_erase >> $output 2>&1
$dfuprog $target $opt_flash "$(dirname "$0")"/firmwares/new"$model"-vial-"$vialver"_"$nathanaver".hex >> $output 2>&1
echo \* Flashing \""$keymap"\" keymap...
$dfuprog $target $opt_eeprom "$(dirname "$0")"/keymaps/"$model"/"$keymap"-"$model".hex >> $output 2>&1
echo \* Rebooting keyboard controller...
$dfuprog $target $opt_reset >> $output 2>&1
echo
echo ...done!
echo
read -p "Press any key to continue . . . " key
echo
